//=============================================================================
// ChallengeDominationHUD.
//=============================================================================
class betaDominationHUD extends ChallengeHUD;

var Texture TeamIcons[5];
var() color TeamColors[5];
var() color AltTeamColors[5];

var() name OrderNames[16];
var() int NumOrders;

simulated function PostRender( canvas Canvas )
{
	local cpoint blip;
   local int CenterX, CenterY;
   local vector RelLoc;
   local float d, x, y, arc;
   local actor Viewer;
   local float XL, YL;
   local texture texy;

super.postrender(canvas);

	Canvas.Style = erenderstyle.sty_masked;
	//Canvas.Font = font'smallredfont';

  CenterX = 0.5 * Canvas.ClipX - 64 + 64;
  CenterY = 16 + 200;


   Viewer = Owner;
   if (playerpawn(owner)!=none&&PlayerPawn(Owner).ViewTarget != none)
      Viewer = PlayerPawn(Owner).ViewTarget;

   foreach allActors(class'cpoint', blip)
            if(blip!=none&&blip.isa('cpoint'))
{

         RelLoc = viewer.Location - blip.Location;
         arc = (Viewer.Rotation.Yaw - 16384) / 187.04 / 360;
         d = arc * 2 * PI;
         x =  RelLoc.X * cos(d) + RelLoc.Y * sin(d);
         y = -RelLoc.X * sin(d) + RelLoc.Y * cos(d);
         x /= 14;
         y /= 14;
         x += CenterX - 1;
         y += CenterY - 1;

         Canvas.SetPos(x,y);

if(blip!=none&&blip.IsA('cpoint'))
{
 Canvas.DrawColor = TeamColors[blip.team];Canvas.DrawIcon(Teamicons[blip.team], 0.5);
 if(blip.controller==owner){Canvas.SetPos(x, Y + 50 * Scale - YL);Canvas.DrawText("Captured");}
else if(blip.controller!=owner){Canvas.SetPos(x, Y + 50 * Scale - YL);Canvas.DrawText(""$blip.name);}}
		 


}
}



defaultproperties
{
TeamIcons(0)=Texture'I_TeamR'
    TeamIcons(1)=Texture'I_TeamB'
    TeamIcons(2)=Texture'I_TeamG'
    TeamIcons(3)=Texture'I_TeamY'
    TeamIcons(4)=Texture'I_TeamN'
    TeamColors(0)=(R=255,G=0,B=0,A=0),
    TeamColors(1)=(R=0,G=128,B=255,A=0),
    TeamColors(2)=(R=0,G=255,B=0,A=0),
    TeamColors(3)=(R=255,G=255,B=0,A=0),
    TeamColors(4)=(R=255,G=255,B=255,A=0),
    AltTeamColors(0)=(R=200,G=0,B=0,A=0),
    AltTeamColors(1)=(R=0,G=94,B=187,A=0),
    AltTeamColors(2)=(R=0,G=128,B=0,A=0),
    AltTeamColors(3)=(R=255,G=255,B=128,A=0),
    OrderNames(0)=Defend
    OrderNames(1)=Hold
    OrderNames(2)=Attack
    OrderNames(3)=Follow
    OrderNames(4)=Freelance
    OrderNames(5)=Point
    OrderNames(10)=Attack
    OrderNames(11)=Freelance
    ServerInfoClass=Class'ServerInfoDOM'
}
