//=============================================================================
// ControlPoint.
//=============================================================================
class CPoint extends navigationpoint;

var TeamInfo ControllingTeam;
var Pawn Controller;
var() Name RedEvent;
var() Name BlueEvent;
var() Name GreenEvent;
var() Name GoldEvent;
var() bool bSelfDisplayed;
var() localized String PointName;
var() Sound ControlSound;	
var   int ScoreTime, Team;
var   bool bScoreReady;
var() string name;

replication
{
reliable if( (role ==role_authority) )
            team,name,controller;
}


simulated function PostBeginPlay()
{
	
	
		Super.PostBeginPlay();
		bHidden = !bSelfDisplayed;
	
		SetTimer(3.0, true);
	// Log the event.
	if (Level.Game.LocalLog != None)
	{
		Level.Game.LocalLog.LogSpecialEvent("controlpoint_created", PointName);
	}
	if (Level.Game.WorldLog != None)
	{
		Level.Game.WorldLog.LogSpecialEvent("controlpoint_created", PointName);

	}

spawn(class'attract',,,location);
}

simulated function string GetHumanName()
{
	return PointName;
}

simulated function Touch(Actor Other)
{
	
if(other.isa('pawn')&&controller!=pawn(other))
{
	Controller = Pawn(Other);
	if ( Controller.IsA('Bot') && (Controller.MoveTarget == self) )
		Controller.MoveTimer = -1.0; // stop moving toward this

name=Controller.PlayerReplicationInfo.playername;

if ( Controller.PlayerReplicationInfo.Team == 0 )
		{
			
			if ( bSelfDisplayed )
			{
				DrawScale=0.7;
				Mesh = mesh'DomR';
				Texture = texture'RedSkin2';
				LightHue=0;
			}
team = 0;
		}
		else if ( Controller.PlayerReplicationInfo.Team == 1 )
		{
			
			if ( bSelfDisplayed )
			{
				DrawScale=0.7;
				Mesh = mesh'DomB';
				Texture = texture'BlueSkin2'; 
				LightHue=170;
			}
team = 1; 
		}
		else if ( Controller.PlayerReplicationInfo.Team == 2 )
		{
			
			if ( bSelfDisplayed )
			{
				DrawScale=1.3;
				Mesh=mesh'UDamage';
				Texture=Texture'UnrealShare.NewGreen'; //FireTexture'UnrealShare.Belt_fx.ShieldBelt.Greenshield'; 
				LightHue=85;
			}
team = 2;
		}
		else if ( Controller.PlayerReplicationInfo.Team == 3 )
		{
			
			if ( bSelfDisplayed )
			{
				DrawScale=0.7;
				Mesh=mesh'MercSymbol';
				Texture=texture'GoldSkin2';
				LightHue=35;
			}
team = 3;
		}
		else if ( Controller.PlayerReplicationInfo.Team == 255 )
		{
			
			if ( bSelfDisplayed )
			{
				DrawScale=0.7;
				Mesh=mesh'DomN';
				Texture=texture'jdomn0';
				LightHue=35;
			}
team = 4;
		}
	UpdateStatus();
}
}

simulated function UpdateStatus()
{
	local Actor A;
	local Name E;
	local TeamInfo NewTeam;
	local TeamGamePlus T;
	local Bot B, B2;
	local Pawn P;
	local bool bNeedDefense, bTempDefense;


	
	// Log the event.
		if (Level.Game.LocalLog != None)
		{
			Level.Game.LocalLog.LogSpecialEvent("controlpoint_capture", PointName, Controller.PlayerReplicationInfo.PlayerID);
		}
		if (Level.Game.WorldLog != None)
		{
			Level.Game.WorldLog.LogSpecialEvent("controlpoint_capture", PointName, Controller.PlayerReplicationInfo.PlayerID);
		}
		PlaySound(ControlSound, SLOT_None, 12.0);

		B = Bot(Controller);
				if ( Controller.IsA('TournamentPlayer') )
		{
			
			if ( DeathMatchPlus(Level.Game).bRatedGame
					&& (Controller == DeathMatchPlus(Level.Game).RatedPlayer) )
				DeathMatchPlus(Level.Game).bFulfilledSpecial = true;
		}
	
	if ( bSelfDisplayed )
		bHidden = false;

	if ( Controller == None )
	{
		bScoreReady = false;
		E = '';
		if ( bSelfDisplayed ) 
		{
			DrawScale=0.4;
			Mesh = mesh'DomN';
			Texture=texture'JDomN0';
			LightHue=0;
		    LightSaturation=255;
		}
	}	
	else
	{
		ScoreTime = 2;
		SetTimer(3.0, true);
			}
	if ( E != '' )
		foreach AllActors(class'Actor', A, E )
		 Trigger(self, Controller);
}

simulated function Timer()
{
if(controller!=none&&controller.physics!=phys_none)
{

controller.playerreplicationinfo.score+=1;

if(controller.playerreplicationinfo.score>=deathmatchplus(level.game).fraglimit)
   deathmatchplus(level.game).Killed(controller,none,'ss');}
}

defaultproperties
{
    bSelfDisplayed=True
    PointName=""
    ControlSound=Sound'ControlSound'
    bStatic=False
    //bNoDelete=True
    team=4
    bAlwaysRelevant=True
    Physics=phys_rotating
    RemoteRole=role_simulatedproxy
    DrawType=dt_mesh
    Texture=Texture'JDomN0'
    Mesh=LodMesh'DomN'
    DrawScale=0.40
    AmbientGlow=255
    bUnlit=True
    bMeshEnviroMap=True
    SoundRadius=64
    SoundVolume=255
    bCollideActors=True
    LightType=lt_steady
    LightEffect=13
    LightBrightness=255
    LightHue=170
    LightSaturation=255
    LightRadius=7
    bFixedRotationDir=True
    RotationRate=(Pitch=0,Yaw=5000,Roll=0),
    DesiredRotation=(Pitch=0,Yaw=30000,Roll=0),
}
