//=============================================================================
// Domination.
//=============================================================================
class betaDomination extends deathmatchPlus
	config;

var bool bNeutralPoints;
var config bool bDumbDown;			// reduce efficiency of bot team AI
var cpoint cpoints[16]; // control point list used for AI
									// (so game could have more than 16, but bots will only understand first 16
var int DomScoreEvent;				// used to track when to dump out periodic stat information

function PreBeginPlay()
{
	local NavigationPoint N;
	local int TempTotal;

	Super.PreBeginPlay();


	for ( N=Level.NavigationPointList; N!=None; N=N.NextNavigationPoint )		if ( N.IsA('controlpoint') )
		{
			spawn(class'cpoint',,,n.location,n.rotation);n.destroy();
		}
}
function PostBeginPlay()
{
	local NavigationPoint N;
	local int TempTotal;

	Super.PostBeginPlay();


	for ( N=Level.NavigationPointList; N!=None; N=N.NextNavigationPoint )
		if ( N.IsA('cpoint') )
		{
			cpoints[TempTotal] = cpoint(N);
			TempTotal++;
		}
}

function ScoreKill(pawn Killer, pawn Other)
{
	Super.ScoreKill(Killer, Other);

}

function InitRatedGame(LadderInventory LadderObj, PlayerPawn LadderPlayer)
{
	bDumbDown = True;
	Super.InitRatedGame(LadderObj, LadderPlayer);
}



function Timer()
{
	local NavigationPoint N;
	local cpoint CP;
	local int i;
	local float c;
	local PlayerReplicationInfo PRI;

	if ( !bGameEnded )
	{
		c = 0.2;
		if ( TimeLimit > 0 )
		{
			if ( RemainingTime < 0.25 * TimeLimit )
			{
				if ( RemainingTime < 0.1 * TimeLimit )
					c = 0.8;
				else
					c = 0.4;
			}
		}

		if ( !bRequireReady || (CountDown <= 0) )
			for ( N=Level.NavigationPointList; N!=None; N=N.nextNavigationPoint )
			{
				CP = cpoint(N);
				if ( (CP != None) && (CP.ControllingTeam != None) && CP.bScoreReady )
				{
					//CP.ControllingTeam.Score += c;
					 CP.Controller.PlayerReplicationInfo.Score+= c;
                                        if(CP.Controller.PlayerReplicationInfo.Score>=fraglimit)level.game.Killed(cp.controller,none,'ss');
				}
			}
		DomScoreEvent++;
		if (DomScoreEvent >= 5)
		{
			DomScoreEvent = 0;
			for (i=0; i<4; i++)
			{
				
			}
			for (i=0; i<32; i++)
			{
				PRI = GameReplicationInfo.PRIArray[i];
				if (PRI != None)
				{
					if (Level.Game.WorldLog != None)
						Level.Game.WorldLog.LogSpecialEvent("dom_playerscore_update", PRI.PlayerID, int(PRI.Score));
					if (Level.Game.LocalLog != None)
						Level.Game.LocalLog.LogSpecialEvent("dom_playerscore_update", PRI.PlayerID, int(PRI.Score));				
				}
			}
		}
			}
	Super.Timer();
}

function bool CanTranslocate(Bot aBot)
{
	if ( aBot.bNovice && (aBot.Skill < 2) )
		return false;
	return Super.CanTranslocate(aBot);
} 

function ClearControl(Pawn Other)
{
	local NavigationPoint N;
	local Pawn P, Pick;
	local int Num;

	// find a teammate
	if ( !Other.bIsPlayer || (Other.PlayerReplicationInfo.Team == 255) )
		return;

	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
		if ( P.bIsPlayer && (P != Other) && (P.PlayerReplicationInfo.Team == Other.PlayerReplicationInfo.Team) )
		{
			Num++;
			if ( (Pick == None) || (Rand(Num) == 1) )
				Pick = P;
		}
	for ( N=Level.NavigationPointList; N!=None; N=N.nextNavigationPoint )
		if ( N.IsA('cpoint') && (cpoint(N).ControllingTeam != None) )
		{
			if ( cpoint(N).Controller == Other )
			{
				cpoint(N).Controller = Pick;
				cpoint(N).UpdateStatus();
			}
		}
}

function Logout( pawn Exiting )
{
	ClearControl(Exiting);
	Super.Logout(Exiting);
}




function bool FindSpecialAttractionFor(Bot aBot)
{
	local float bestweight, newweight;
	local cpoint Best, Near;
	local int i, count, maxdist, t;
	local bool bOrdered, bFound, bBehind;

	if ( aBot.LastAttractCheck == Level.TimeSeconds )
		return false;
	aBot.LastAttractCheck = Level.TimeSeconds;

	if ( aBot.Orders == 'Defend' )
	{
		if ( (aBot.OrderObject == None) || !aBot.OrderObject.IsA('cpoint') )
			aBot.Orders = 'FreeLance';
		else if ( (cpoint(aBot.OrderObject).ControllingTeam == None)
					|| (cpoint(aBot.OrderObject).ControllingTeam.TeamIndex != aBot.PlayerReplicationInfo.Team) )
		{
			if ( VSize(aBot.OrderObject.Location - aBot.Location) < 20 )
			{
				aBot.OrderObject.Touch(aBot);
				return false;
			}
			else if ( aBot.ActorReachable(aBot.OrderObject) )
			{
				bFound = true;
				aBot.MoveTarget = aBot.OrderObject;
			}
			else
			{
				aBot.MoveTarget = aBot.FindPathToward(aBot.OrderObject);
				bFound = ( aBot.MoveTarget != None );
			}
			if ( bFound )
			{
				if ( aBot.Enemy != None )
					aBot.bReadyToAttack = true;
				SetAttractionStateFor(aBot);
				return true;
			}
			return false;
		}
		else
			return false;					
	}
	// also "no movetarget"	in fallback		
	bOrdered = (aBot.Orders == 'Follow') || (aBot.Orders == 'Hold');
	if ( !bOrdered && bDumbdown && aBot.bDumbdown && !bNeutralPoints )
	{
		
		bOrdered = !bBehind;
	}
				
	if ( bOrdered || (aBot.Enemy != None) || (aBot.Weapon == None) 
		|| (aBot.Weapon.AIRating < 0.5) || (aBot.Health < 70) )
	{
		if ( bOrdered )
			MaxDist = 1200;
		else
			MaxDist = 1700;
		// change nearby enemy or neutral cpoint
		i = 0;
		bNeutralPoints = false;
		while ( (i<16) && (cpoints[i] != None) )
		{
			if ( ((cpoints[i].ControllingTeam == None) 
				|| (cpoints[i].ControllingTeam.TeamIndex != aBot.PlayerReplicationInfo.Team))
				&& (VSize(aBot.Location - cpoints[i].Location) < MaxDist)
				&& aBot.LineOfSightTo(cpoints[i]) )
			{
				if ( cpoints[i].ControllingTeam == None )
				{
					bNeutralPoints = true;
					if ( bOrdered && (aBot.Orders != 'Follow') && (aBot.Orders != 'Hold') )
					{
						aBot.bDumbDown = false; 
						bOrdered = false;
					}
				}
									
				if ( VSize(cpoints[i].Location - aBot.Location) < 20 )
				{
					cpoints[i].Touch(aBot);
					return false;
				}
				else if ( aBot.ActorReachable(cpoints[i]) )
				{
					bFound = true;
					aBot.MoveTarget = cpoints[i];
				}
				else if ( !bOrdered )
				{
					aBot.OrderObject = cpoints[i];
					BotReplicationInfo(aBot.PlayerReplicationInfo).OrderObject = None;
					aBot.MoveTarget = aBot.FindPathToward(cpoints[i]);
					bFound = ( aBot.MoveTarget != None );
				}
				if ( bFound )
				{
					if ( aBot.Enemy != None )
						aBot.bReadyToAttack = true;
					SetAttractionStateFor(aBot);
					return true;
				}
			}	
			i++;
		}
		if ( bOrdered || (aBot.Enemy == None) )
			return false;

		i = 0;
		while ( (i<16) && (cpoints[i] != None) )
		{
			if ( (cpoints[i].ControllingTeam == None) 
				|| (cpoints[i].ControllingTeam.TeamIndex != aBot.PlayerReplicationInfo.Team) )
				Count--;
			else
				Count++;
			i++;
		}
		if ( Count > 0 )
			return false; // already have an advantage in control points
	}

	//log("Find Special Attraction for"@aBot@"in state"@aBot.GetStateName());

	Best = cpoint(aBot.OrderObject);
	if ( (Best == None)
		|| ((Best.ControllingTeam != None)
			&& (Best.ControllingTeam.TeamIndex == aBot.PlayerReplicationInfo.Team)))
	{
		bestweight = 10000000;
		while ( (i<16) && (cpoints[i] != None) )
		{
			if ( cpoints[i].ControllingTeam == None )
				newweight = VSize(cpoints[i].location - aBot.location) * 0.1;
			else if ( (cpoints[i].ControllingTeam.TeamIndex != aBot.PlayerReplicationInfo.Team) )
			{
				newweight = VSize(cpoints[i].location - aBot.location) + 2 * Abs(cpoints[i].Location.Z - aBot.Location.Z);
				newweight *= (0.8 + 0.4 * FRand());
			}
			else 
				newweight = 90000000;

			if ( newweight < bestweight )
			{
				bestweight = newweight;
				Best = cpoints[i];
			}
			i++;
		}
	}

	if ( Best != None )
	{
		BotReplicationInfo(aBot.PlayerReplicationInfo).OrderObject = None;
		aBot.OrderObject = Best;
		if ( VSize(Best.Location - aBot.Location) < 20 )
		{
			aBot.OrderObject = None;
			Best.Touch(aBot);
			return false;
		}
		else if ( aBot.ActorReachable(Best) )
			aBot.MoveTarget = Best;
		else
			aBot.MoveTarget = aBot.FindPathToward(Best);

		if ( aBot.MoveTarget != None )
		{
			if ( aBot.bVerbose )
				log(aBot$" moving toward "$Best$" using "$aBot.MoveTarget);
			SetAttractionStateFor(aBot);
			return true;
		}
		else 
		{
			if ( FRand() < 0.3 )
				aBot.OrderObject = None;
			if ( aBot.bVerbose )
				log(aBot@"no path to"@Best.PointName);
		}
			
	}
	else if ( aBot.bVerbose )
		log(aBot@"found no best control point");
	return false;
}

function SetAttractionStateFor(Bot aBot)
{
	if ( aBot.Enemy != None )
	{
		if ( !aBot.IsInState('FallBack') )
		{
			aBot.bNoClearSpecial = true;
			aBot.TweenToRunning(0.1);
			aBot.GotoState('FallBack','SpecialNavig');
		}
	}
	else if ( !aBot.IsInState('Roaming') )
	{
		aBot.bNoClearSpecial = true;
		aBot.TweenToRunning(0.1);
		aBot.GotoState('Roaming', 'SpecialNavig');
	}
}
defaultproperties
{
    bDumbDown=True
    bScoreTeamKills=False
    fraglimit=50.00
    bUseTranslocator=True
    bRatedTranslocator=True
    StartUpMessage="Capture and hold control points to win."
    gamegoal="points wins the match!"
    LadderTypeIndex=3
    bCoopWeaponMode=True
    
    ScoreBoardType=Class'TournamentScoreboard'
    HUDType=Class'betaDominationHUD'
    MapListType=Class'DOMMapList'
    MapPrefix="DOM"
    BeaconName="DOM"
    GameName="Beta Domination"
}
